/*********************************************************************************************/

/**********************************************/
/* The following are the icon build functions */
/**********************************************/

//static void Make_Glow_Mask(struct IconImage *im, WORD topoffset, WORD deltasize, struct Window *win)
//static void Make_Image_Tile(struct IconImage *im, WORD topoffset, WORD deltasize, struct Window *win)
//static void Clean_Glow_Mask(struct IconImage *im, WORD topoffset, WORD deltasize, struct Window *win)
//static void Change_Glow_Tint(struct IconImage *im, WORD topoffset, WORD deltasize, struct Window *win)
//static void Finish_Glow_Mask(struct IconImage *im, WORD topoffset, WORD deltasize, struct Window *win)
//static void Apply_Glow_Mask(struct IconImage *im, WORD topoffset, WORD deltasize, struct Window *win)
//static void Build_Icons(struct IconImage *im, WORD topoffset, WORD deltasize, struct Window *win)

//Note: Build_Icons & Single_Icon will be menu items in a future update to add a project menu system.

/*********************************************************************************************/

static void Make_Glow_Mask(struct IconImage *im, WORD topoffset, WORD deltasize, struct Window *win)
{    
    int srce_x;
    int srce_y;
    int center_x;
    int center_y;
    
    /* Center of Icon Image */
	center_x = ((80-im->Width)/2);
	center_y = ((80-im->Height)/2);

    /* Calculate Srce_x * Srce_y */
    /* Top left of Second Raised Panel */
    srce_x = 396 + center_x + deltasize;	
	srce_y = 25 + topoffset + center_y + deltasize;    
    
    /* Get Contour Chaincode */
    struct ChainCode *chaincode;
    //chaincode = Detect_Contour(im);

    /* Pre-Set Chaincode for Testing */
    //data for def_picture image
    chaincode->Count = 31;
    chaincode->Ctrl_X = 5;
    chaincode->Ctrl_Y = 16;     
    //chaincode->Code = { 0x42, 0x26, 0x43, 0x26, 0x44, 0x26, 0x41, 0x26 }; //{b,38,c,38,d,38,a,38}; //Or 37?
    chaincode->Code[0] = 'b';
    chaincode->Code[1] = 37;
    chaincode->Code[2] = 0x43;
    chaincode->Code[3] = 0x26;
    chaincode->Code[4] = 0x44;
    chaincode->Code[5] = 0x26;
    chaincode->Code[6] = 0x41;
    chaincode->Code[7] = 0x26;
    //b,c,d,a for a rectangular shape contour //'A'=0x41, 'B'=0x42 'C'=0x43'D'=0x44 

    //Make_Image_Tile(srce_x, srce_y, im, win);
    //Clean_Image_Tile(srce_x, srce_y, im, win);
    Draw_Glow_Mask(chaincode, srce_x, srce_y, im, win);   
}

/*********************************************************************************************/

static void Draw_Glow_Mask(struct ChainCode *chaincode, int srce_x, int srce_y, struct IconImage *im, struct Window *win)
{
    int x, y;
    int i, j, k;
    int srce_xy;
    char *color;
    int control_x;
    int control_y;
    int chaincount;
    UBYTE chain_code[100];    
    unsigned char codevalue;
    unsigned char direction;        

    control_x = chaincode->Ctrl_X;
    control_y = chaincode->Ctrl_Y;
    chaincount = chaincode->Count;
    Printf("Chain Count: %d\n", chaincount);

	int bpp;    
    BOOL retval = TRUE;   
    int width, height, depth;
    struct BitMapHeader *bmhd;
    UBYTE *pixelBuffer;

	/* Output Filename */
    char *tempfilename = "Ram Disk:temp.png";
    
    /* Find Width, Height & Depth of Image */
    bmhd = readbmhd_by_datatype(infilename2);
    width = bmhd->bmh_Width;
    height = bmhd->bmh_Height;
    depth = bmhd->bmh_Depth;
    bpp = (depth/8);

	pixelBuffer = (UBYTE *)AllocMem(width * height * bpp, MEMF_ANY);
    
    retval = ReadPixels_by_datatype(pixelBuffer, infilename2, bpp);
     

    /* Coordinates of Control Point */
    //srce_xy = (y * width + x) * 4;
    //srce_xy = (control_y * im->Width + control_x) * 4;

     
    //if(stricmp(color, "white")==0)
    //{
        //GetPixel32(color, pixel32);               
    //
    //else if(stricmp(color, "gold")==0)
    //{
        //GetPixel32(color, pixel32);               
    //}
    //else if(stricmp(color, "orange")==0)
    //{
        //GetPixel32(color, pixel32);               
    //}

    //GetPixel32(color, pixel32);
    //MyPixel = GetUint32(pixel32);

    
    /**************/
    /* Chain Code */
    /**************/

    //4-connected & 8-connected chain codes
    //8-connected chain codes seem to be better to describe diagonal direction
    //changes. Where 4-connected chain codes can't accurately describe those.   


    //Python example of how to interpret the chain code
    //freeman_code = [3, 3, 3, 6, 6, 4, 6, 7, 7, 0, 0, 6]
    //img = np.zeros((10,10))

    //x, y = 4, 4 //control point
    //img[y][x] = 1
    //for direction in freeman_code:
    //if direction is [1,2,3]:
        //y -= 1
    //if direction is [5,6,7]:
        //y += 1
    //if direction is [3,4,5]:
        //x -= 1
    //if direction is [0,1,7]:
        //x += 1

    //img[y][x] = 1


    /*****************/
    /* Drawing Rules */
    /*****************/

    //contour shape components:
    //angled edge, feathered edge, straight edge, right angle, 
    //in-set, out-set, combined in-set, curved edge, rift edge

    //three shape types: irregular, rectangular, rounded.

    //note: combined in-set in a in-set area where the distance between sides is 2 pixels or less.    
    //rectangular shape countour has four straight edges & four right angles. it is the simplest shape.
    //rounded shape contours are composed of short straight edges at the middle of the quadrants 
    //surrounded by four curved edges between the quadrants with multiple vertices. this is a complex shape.
    //irregular shape contours are composed of multiple rounded areas or angular areas or both types.

    //for rectangular shape contours at the right angle vertices the white pixels are offset parallel to
    //perimeter pixels, gold pixels and orange pixels are also offset parallel but they also fill gaps.    
    //the corner vertices will be two perpendicular white bands with a gold pixel at the vertex point to fill the gap
    //between the white pixels.
    //outside of that will be the gold band or pixels offset parallel to the white pixels. gold pixels also fill the gaps 
    //between white pixel vertices.
    //the outermost band is orange pixels that are offset parallel to the white pixels. orange pixels also fill the gaps 
    //between gold pixel vertices.

    //To detect whether there is a straight edge, angled edge, or curved edge
    //use the Angle Method based on current direction & previous direction.

    //Also a straight edge will have all the same x, or y values depending on
    //if it is a horizontal or vertical line segment. A line segment is 2 or
    //more adjacent pixels that share either the same x or y coordinates.

    //An angled edge will have pixels where the x, y coordinates have a 
    //defined pattern that indicates a 45 degree angle rather than right angle.

    //Clean the Glow Mask after the Make Glow Mask Operation.
    //Use the chaincode shape contour to change the inside RGB pixels to white.
    //Alternatively change the RGB pixels to white before making the Glow Mask.
    

    /*********************************************/
    /* Use Chain Code to Draw New Colored Pixels */
    /*********************************************/

    //Follow the chaincode three times, once for each color
    //Setup a for-loop using the chaincount to process each chaincode value
    //Start at the control point each time to begin processing the chaincode.
    //Get the coordinates from each perimeter pixel using the chaincode values.
    //For each perimeter pixel search directions a,b,c,d wih p as the centroid.
    //For straight edges & rift edges use a 'k' loop to process the pixels.
    //Use a 'k' loop to process two or more pixels in a line segment.
    //Perimeter pixels will be adjacent to at least one background pixel (non-pixel).
    //Pixels located at a vertex may be adjacent to more than one non-pixel.
    //The adjacent non-pixels are where the new colored mask pixels will be placed.
    //The mask pixels will be placed according to the currently selected color.
    //The selected color is a char array of either "white", "gold", "orange".
    //The Write_Mask function handles making ULONG Pens & drawing mask pixels.
    

    /* First Color */
    //color = ("black"); 
        
    /* Write black pixel to original then write to large image */
    //Write_Mask(color, srce_x, srce_y, control_x-1, control_y-1, im, win);
    
    /* Start Point */
    x = control_x-1;
    y = control_y-1;
    Printf("Chain Control_X: %d\n", x);
    Printf("Chain Control_Y: %d\n", y);
    
    //i = 0;
    for(i = 0; i < 3; i++)
    {
        /* Set Colors by Numbers */
        if(i == 0) color = ("white");
        if(i == 1) color = ("gold");
        if(i == 2) color = ("orange");
        Printf("Glow Mask Color: %s\n", color);
              
        /* Process the Control Point Seperately */        
        //Printf("Process the first pixel in the series!!!\n");                                 
        Check_Pixel(i, direction, color, srce_x, srce_y, x, y-1, win);                    
        Check_Pixel(i, direction, color, srce_x, srce_y, x+1, y, win);                   
        Check_Pixel(i, direction, color, srce_x, srce_y, x, y+1, win);                    
        Check_Pixel(i, direction, color, srce_x, srce_y, x-1, y, win);

        //if there is a direction change then there is a right angle
        //if color = "white" draw a "gold" pixel to fill the gap at the end
        //if(stricmp(color, "white")==0) color = ("gold");
        //if(stricmp(color, "gold")==0) color = ("orange");
        //Color will be reset at the top of the for-loop
        //Check_Pixel(color, srce_x, srce_y, x-1, y, im, win);
        
        //def_Picture new //5,5
	    //chain_code[0] = 'c';
        //chain_code[1] = 37;        
        //chain_code[2] = 'e';
        //chain_code[3] = 37;
        //chain_code[4] = 'g';
        //chain_code[5] = 37;
        //chain_code[6] = 'a';
        //chain_code[7] = 37;
        
        //def_Picture old //5,5
	    //chain_code[0] = 'b';
        //chain_code[1] = 37;        
        //chain_code[2] = 'c';
        //chain_code[3] = 37;
        //chain_code[4] = 'd';
        //chain_code[5] = 37;
        //chain_code[6] = 'a';
        //chain_code[7] = 37;

	    //def_LS-120 //6,5
		//chain_code[0] = 'c';
        //chain_code[1] = 33;
		//chain_code[2] = 'd';
        //chain_code[3] = 2;
		//chain_code[4] = 'e';
        //chain_code[5] = 35;
		//chain_code[6] = 'g';
        //chain_code[7] = 35;
        //chain_code[8] = 'a';
        //chain_code[9] = 37;

		//def_ram4b //6,5
		//chain_code[0] = 'c';
        //chain_code[1] = 35;
		//chain_code[2] = 'd';
        //chain_code[3] = 1;
		//chain_code[4] = 'e';
        //chain_code[5] = 35;
		//chain_code[6] = 'f';
        //chain_code[7] = 1;
		//chain_code[8] = 'g';
        //chain_code[9] = 35;
		//chain_code[10] = 'h';
        //chain_code[11] = 1;
        //chain_code[12] = 'a';
        //chain_code[13] = 35;
		//chain_code[14] = 'b';
        //chain_code[15] = 1;

		//def_floppy2_blue //6,5
        //chain_code[0] = 'c';
        //chain_code[1] = 23;
        //chain_code[2] = 'd';
        //chain_code[3] = 1;
        //chain_code[4] = 'c';
        //chain_code[5] = 5;
        //chain_code[6] = 'b';
        //chain_code[7] = 1;
        //chain_code[8] = 'c';
        //chain_code[9] = 3;
		//chain_code[10] = 'd';
        //chain_code[11] = 2;
        //chain_code[12] = 'e';
        //chain_code[13] = 35;
		//chain_code[14] = 'g';
        //chain_code[15] = 35;
        //chain_code[16] = 'a';
        //chain_code[17] = 37;

		//MultiView2 //5,16
        chain_code[0] = 'c';
        chain_code[1] = 12;
        chain_code[2] = 'b';
        chain_code[3] = 1;
        chain_code[4] = 'a';
        chain_code[5] = 1;
        chain_code[6] = 'b';
        chain_code[7] = 1;
        chain_code[8] = 'a';
        chain_code[9] = 2;
        chain_code[10] = 'b';
        chain_code[11] = 4;
        chain_code[12] = 'c';
        chain_code[13] = 2;
        chain_code[14] = 'b';
        chain_code[15] = 1;
        chain_code[16] = 'c';
        chain_code[17] = 8;
        chain_code[18] = 'd';
        chain_code[19] = 1;
        chain_code[20] = 'c';
        chain_code[21] = 1;
        chain_code[22] = 'c';
        chain_code[23] = 1;
        chain_code[24] = 'd';
        chain_code[25] = 5;
        chain_code[26] = 'e';
        chain_code[27] = 3;
        chain_code[28] = 'c';
        chain_code[29] = 1;
        chain_code[30] = 'e';
        chain_code[31] = 8;
        chain_code[32] = 'f';
        chain_code[33] = 1;
        chain_code[32] = 'e';
        chain_code[33] = 1;
        chain_code[32] = 'f';
        chain_code[33] = 1;
        chain_code[34] = 'e';
        chain_code[35] = 13;
        chain_code[36] = 'f';
        chain_code[37] = 2;
        chain_code[38] = 'g';
        chain_code[39] = 4;
        chain_code[40] = 'h';
        chain_code[41] = 2;
        chain_code[42] = 'g';
        chain_code[43] = 1;
        chain_code[44] = 'f';
        chain_code[45] = 1;
        chain_code[46] = 'e';
        chain_code[47] = 3;
        chain_code[48] = 'f';
        chain_code[49] = 2;
        chain_code[50] = 'g';
        chain_code[51] = 4;
        chain_code[52] = 'h';
        chain_code[53] = 2;
        chain_code[54] = 'a';
        chain_code[55] = 4;
        chain_code[56] = 'h';
        chain_code[57] = 1;
        chain_code[58] = 'g';
        chain_code[59] = 16;
        chain_code[60] = 'a';
        chain_code[61] = 19;
        
        
        for(j = 0; j < chaincount; j++)
        {
            /* Set Colors by Numbers */
            if(i == 0) color = ("white");
            if(i == 1) color = ("gold");
            if(i == 2) color = ("orange");
            Printf("Glow Mask Color: %s\n", color); 
            
            /* Move to the Next Perimerter Pixel */
            direction = chain_code[j*2]; //a,b,c,d            
            Printf("***Chain Code Direction: %d\n", direction);
            Printf("***Chain Code j Value: %d\n", j);
            
            //if(direction == 'e') //if direction is [1,2,3]:
            //if(direction == 'f') //if direction is [5,6,7]:
            //if(direction == 'g') //if direction is [3,4,5]:
            //if(direction == 'h') //if direction is [0,1,7]:

            codevalue = chain_code[j*2 + 1];                        
            Printf("***Chain Code Value: %d\n", codevalue);
			  
            		//if(direction == 'a' || direction == 'b' || direction == 'c' || direction == 'd') //a,b,c,d	   
			if(direction == 'a' || direction == 'c' || direction == 'e' || direction == 'g') //a,c,e,g
			{
                if(codevalue > 1) 
                {
                    Printf("K-Loop Linear Value: %d\n", codevalue);
                    /* Set k-loop for pixel run */
                    for(k = 0; k < codevalue; k++)
                    {
                        //search directions a,c,e,g wih p as the centroid                   
                        Check_Pixel(i, direction, color, srce_x, srce_y, x, y-1, win);                    
                        Check_Pixel(i, direction, color, srce_x, srce_y, x+1, y, win);                   
                        Check_Pixel(i, direction, color, srce_x, srce_y, x, y+1, win);                    
                        Check_Pixel(i, direction, color, srce_x, srce_y, x-1, y, win);
                        
                        /* Increment the new pixel */
                        if(direction == 'a') y -= 1; //a
                        if(direction == 'c') x += 1; //c
                        if(direction == 'e') y += 1; //e
                        if(direction == 'g') x -= 1; //g
                        
                        /* Increment the new pixel */
                        //if(direction == 'a') y -= 1; //a
                        //if(direction == 'b') x += 1; //c
                        //if(direction == 'c') y += 1; //e
                        //if(direction == 'd') x -= 1; //g 
                    
                    }
                    /* Process the last pixel */
                    Printf("Process the last pixel in the series!!!\n");                                 
                    Check_Pixel(i, direction, color, srce_x, srce_y, x, y-1, win);                    
                    Check_Pixel(i, direction, color, srce_x, srce_y, x+1, y, win);                   
                    Check_Pixel(i, direction, color, srce_x, srce_y, x, y+1, win);                    
                    Check_Pixel(i, direction, color, srce_x, srce_y, x-1, y, win);                                   
                
                    Printf("=============== K-Loop: End of Pixel Line Segment\n"); 
                } 
                else
                {
				    /* Increment the new pixel */
                    if(direction == 'a') y -= 1;
                    if(direction == 'c') x += 1;
                    if(direction == 'e') y += 1;
                    if(direction == 'g') x -= 1;

                    /* Process the Single Pixels Seperately */
                    Printf("=============== Process Single Linear Pixels!!!\n");
                    Check_Pixel(i, direction, color, srce_x, srce_y, x, y-1, win);                    
                    Check_Pixel(i, direction, color, srce_x, srce_y, x+1, y, win);                   
                    Check_Pixel(i, direction, color, srce_x, srce_y, x, y+1, win);                    
                    Check_Pixel(i, direction, color, srce_x, srce_y, x-1, y, win);                
                } 
		    }
			else if(direction == 'b' || direction == 'd' || direction == 'f' || direction == 'h') //b,d,f,h
			{
				if(codevalue > 1)
				{
                    Printf("K-Loop Oblique Value: %d\n", codevalue);
					/* Set k-loop for pixel run */
                    for(k = 0; k < codevalue; k++)
					{
			            //Write_Mask(color, srce_x, srce_y, x, y, im, win);
			            /* Process the Oblique Pixels Seperately */
                        Printf("=============== Process Oblique Pixels!!!\n");
                        Check_Pixel(i, direction, color, srce_x, srce_y, x, y-1, win);                    
                        Check_Pixel(i, direction, color, srce_x, srce_y, x+1, y, win);                   
                        Check_Pixel(i, direction, color, srce_x, srce_y, x, y+1, win);                    
                        Check_Pixel(i, direction, color, srce_x, srce_y, x-1, y, win);
					
						/* Increment the new pixel */
                        if(direction == 'b') 
					    {
					        x += 1; 
				            y -= 1;
					    } 
                        if(direction == 'd') 
					    {
					        x += 1; 
				            y += 1;
					    }
                        if(direction == 'f') 
					    {
					        x -= 1;
					        y += 1;
					    }
                        if(direction == 'h')
					    { 
					        x -= 1;
				            y -= 1;
					    }

                        
					}
				}
				else
                {
	            /* Process Single Oblique Pixels twice for end pixels */
	            /* Process the Single Pixels Seperately */
                    Printf("=============== Process Single Oblique Pixels!!!\n");
                    Check_Pixel(i, direction, color, srce_x, srce_y, x, y-1, win);                    
                    Check_Pixel(i, direction, color, srce_x, srce_y, x+1, y, win);                   
                    Check_Pixel(i, direction, color, srce_x, srce_y, x, y+1, win);                    
                    Check_Pixel(i, direction, color, srce_x, srce_y, x-1, y, win);
				    /* Increment the new pixel */
                    if(direction == 'b') 
					{
					    x += 1; 
				        y -= 1;
					} 
                    if(direction == 'd') 
					{
					    x += 1; 
				        y += 1;
					}
                    if(direction == 'f') 
					{
					    x -= 1;
					    y += 1;
					}
                    if(direction == 'h')
					{ 
					    x -= 1;
				        y -= 1;
					}

                    /* Process the Single Pixels Seperately */
                    Printf("=============== Process Single Oblique Pixels!!!\n");
                    Check_Pixel(i, direction, color, srce_x, srce_y, x, y-1, win);                    
                    Check_Pixel(i, direction, color, srce_x, srce_y, x+1, y, win);                   
                    Check_Pixel(i, direction, color, srce_x, srce_y, x, y+1, win);                    
                    Check_Pixel(i, direction, color, srce_x, srce_y, x-1, y, win);                
                }
			}

        } //end chaincount        
    } //end for(1<3)  
    
    //Save_Large_Image(tempfilename, pixelBuffer, srce_x, srce_y, width, height, win);
	//Save_Large_Image(outfilename, WORD topoffset, WORD deltasize, struct Window *win);

	FreeMem(pixelBuffer, width * height * bpp);
}

/*********************************************************************************************/

static void SaveLargeImage(char *tempfilename, WORD topoffset, WORD deltasize, struct Window *win)
{
	int bpp;
	int i, j;	
	int x, y; 
	int srce_xy;
	ULONG RPixel;
	ULONG MyPixel;
    UBYTE pixel32[4];
    UBYTE rpixel32[4];
	UBYTE *pixelBuffer;
	BOOL retval = TRUE;
	BOOL Is_Pixel = FALSE;
	UWORD srce_x, srce_y;
	UWORD center_x, center_y;
    int width, height, depth;
    struct BitMapHeader *bmhd;    	
	LONG pixelateSize = 2;

    /* Output Filename */
    //char *tempfilename = "Ram Disk:temp.png";
    
    /* Find Width, Height & Depth of Image */
    bmhd = readbmhd_by_datatype(infilename2);
    width = bmhd->bmh_Width;
    height = bmhd->bmh_Height;
    depth = bmhd->bmh_Depth;
    bpp = (depth/8);        
    
    pixelBuffer = (UBYTE *)AllocMem(width * height * bpp, MEMF_ANY);    
    
    retval = ReadPixels_by_datatype(pixelBuffer, infilename2, bpp);

    /* Centered ? */
	center_x = ((80-width)/2);
	center_y = ((80-height)/2);

	/* Top left of Second Raised Panel */
    srce_x = 396 + center_x + deltasize;
	//if(xfactor > 0) srce_x += xfactor;
    srce_y = 25 + topoffset + center_y + deltasize;


	for(x = 0; x < width; x++)
    {
        for(y = 0; y < width; y++)
        {
            /* Coordinates of Current Pixel */
            srce_xy = (y * width + x) * 4;
            pixel32[0] = pixelBuffer[srce_xy];
            pixel32[1] = pixelBuffer[srce_xy + 1];
            pixel32[2] = pixelBuffer[srce_xy + 2];
            pixel32[3] = pixelBuffer[srce_xy + 3];

			//Compare original pixel & rasterport pixel
	        //MyPixel = GetUint32(pixel32);

			j = (x * pixelateSize - 1) + srce_x;        
            i = (y * pixelateSize - 1) + srce_y;
	        //WriteRGBPixel(win->RPort, j + xx + 22, i + yy + 12, MyPixel);
	        RPixel = ReadRGBPixel(win->RPort, j + 22, i + 12);
            PutUint32(rpixel32, RPixel); //Read RasterPort Value

			if(pixel32[0] == 0)
	        {
                //Colors to compare: white, gold, orange
		        if((RPixel == 0x00FFFFFF) || (RPixel == 0x00EFE714) || (RPixel == 0x00DFBA45))
		        {
			        //There's a colored pixel here!			    
			        pixelBuffer[srce_xy] = 255;
					pixelBuffer[srce_xy + 1] = rpixel32[1];
					pixelBuffer[srce_xy + 2] = rpixel32[2];
					pixelBuffer[srce_xy + 3] = rpixel32[3];
		        }
	        }			

            //if(pixel32[0] < 255) Is_Pixel = TRUE;
			//if(pixel32[0] == 255)
            //{
                //if((pixel32[1] == 255) && (pixel32[2] == 255) && (pixel32[3] == 255)) Is_Pixel = TRUE; //white
                //else if((pixel32[1] == 239) && (pixel32[2] == 231) && (pixel32[3] == 20)) Is_Pixel = TRUE; //gold
                //else if((pixel32[1] == 223) && (pixel32[2] == 186) && (pixel32[3] == 69)) Is_Pixel = TRUE; //orange
                //else
                //{
                    /* Set the color to white */
                    //pixelBuffer[srce_xy] = 255;
                    //pixelBuffer[srce_xy + 1] = 255;
                    //pixelBuffer[srce_xy + 2] = 255;
                    //pixelBuffer[srce_xy + 3] = 255;
                //} 
            //}            
        }
    } 

	retval = SavePixels_by_datatype((ULONG *)pixelBuffer, tempfilename, width, height);

	FreeMem(pixelBuffer, width * height * bpp);
}

/*********************************************************************************************/

static void Clean_Glow_Mask(char *tempfilename, WORD topoffset, WORD deltasize, struct Window *win)
{
    int srce_xy;
	int x, y, bpp;	   
    BOOL retval = TRUE;
    UBYTE pixel32[4];
    BOOL Is_Pixel = FALSE;
    int width, height, depth;
    struct BitMapHeader *bmhd;
    UBYTE *pixelBuffer;

    /* Output Filename */
    //char *tempfilename = "Ram Disk:temp.png";
    
    /* Find Width, Height & Depth of Image */
    bmhd = readbmhd_by_datatype(infilename2);
    width = bmhd->bmh_Width;
    height = bmhd->bmh_Height;
    depth = bmhd->bmh_Depth;
    bpp = (depth/8);
        
    
    pixelBuffer = (UBYTE *)AllocMem(width * height * bpp, MEMF_ANY);    
    
    retval = ReadPixels_by_datatype(pixelBuffer, infilename2, bpp);

    
    //For each 32bit pixel check the alpha value
    //if(alpha == 255) && (color != white, gold, orange)
    for(x = 0; x < width; x++)
    {
        for(y = 0; y < width; y++)
        {
            /* Coordinates of Current Pixel */
            srce_xy = (y * width + x) * 4;
            pixel32[0] = pixelBuffer[srce_xy];
            pixel32[1] = pixelBuffer[srce_xy + 1];
            pixel32[2] = pixelBuffer[srce_xy + 2];
            pixel32[3] = pixelBuffer[srce_xy + 3];

            //if(pixel32[0] < 255) Is_Pixel = TRUE;
			if(pixel32[0] == 255)
            {
                if((pixel32[1] == 255) && (pixel32[2] == 255) && (pixel32[3] == 255)) Is_Pixel = TRUE; //white
                else if((pixel32[1] == 239) && (pixel32[2] == 231) && (pixel32[3] == 20)) Is_Pixel = TRUE; //gold
                else if((pixel32[1] == 223) && (pixel32[2] == 186) && (pixel32[3] == 69)) Is_Pixel = TRUE; //orange
                else
                {
                    /* Set the color to white */
                    pixelBuffer[srce_xy] = 255;
                    pixelBuffer[srce_xy + 1] = 255;
                    pixelBuffer[srce_xy + 2] = 255;
                    pixelBuffer[srce_xy + 3] = 255;
                } 
            }
            //if(Is_Pixel == FALSE)
            //{
                
            //}
        }
    }    
    /* Delete Output File if it Exists */
    //if(EXISTS(tempfilename) == TRUE) DeleteFile(tempfilename);
    /* Save PixelBuffer to Temp File */   
    retval = SavePixels_by_datatype((ULONG *)pixelBuffer, tempfilename, width, height);

    //static void Erase_Large_Rectangle(char *imagename, LONG pixelateSize, char *position, WORD deltasize, struct Window *win);
    //Erase_Large_Rectangle(infilename2, pixelateSize, position, deltasize, win);
    //Display_Large_Image(pixelBuffer, width, height, position, deltasize, win);

    FreeMem(pixelBuffer, width * height * bpp);
}

/*********************************************************************************************/

static void Make_Tile_Image(char *tempfilename, WORD topoffset, WORD deltasize, struct Window *win)
{
    int srce_xy;
	int x, y, bpp;    
    BOOL retval = TRUE;
    UBYTE pixel32[4];
    BOOL Is_Pixel = TRUE;
    int width, height, depth;
    struct BitMapHeader *bmhd;
    UBYTE *pixelBuffer;

    /* Output Filename */
    //char *tempfilename = "Ram Disk:temp.png";
    
    /* Find Width, Height & Depth of Image */
    bmhd = readbmhd_by_datatype(infilename2);
    width = bmhd->bmh_Width;
    height = bmhd->bmh_Height;
    depth = bmhd->bmh_Depth;
    bpp = (depth/8);
        
    
    pixelBuffer = (UBYTE *)AllocMem(width * height * bpp, MEMF_ANY);    
    
    retval = ReadPixels_by_datatype(pixelBuffer, infilename2, bpp);

    
    //For each 32bit pixel check the alpha value
    //if(alpha < 255) && (color == white)
    for(x = 0; x < width; x++)
    {
        for(y = 0; y < width; y++)
        {
            /* Coordinates of Current Pixel */
            srce_xy = (y * width + x) * 4;
            pixel32[0] = pixelBuffer[srce_xy];
            pixel32[1] = pixelBuffer[srce_xy + 1];
            pixel32[2] = pixelBuffer[srce_xy + 2];
            pixel32[3] = pixelBuffer[srce_xy + 3];

            if(pixel32[0] == 255) Is_Pixel = TRUE; 
            else if(pixel32[0] < 255) Is_Pixel = FALSE;
            //{
                //if((pixel32[1] != 255) && (pixel32[2] != 255) && (pixel32[3] != 255)) Is_Pixel = FALSE; //white
                //if((pixel32[1] != 0) && (pixel32[2] != 0) && (pixel32[3] != 0)) Is_Pixel = TRUE; //black                 
            //}
            /* Set alpha to zero */
            if(Is_Pixel == FALSE) pixelBuffer[srce_xy] = 0;            
        }
    } 
    /* Delete Output File if it Exists */
    if(EXISTS(tempfilename) == TRUE) DeleteFile(tempfilename);
    /* Save PixelBuffer to Temp File */   
    retval = SavePixels_by_datatype((ULONG *)pixelBuffer, tempfilename, width, height);

    //Erase_Rectangle( )
    //Display_Large_Image(pixelBuffer, width, height, position, deltasize, win);

    FreeMem(pixelBuffer, width * height * bpp);
}

/*********************************************************************************************/

static void Check_Pixel(int band, char dir, char *color, int srce_x, int srce_y, int x, int y, struct Window *win)
{
    int bpp;
	int i, j;	
    int srce_xy;
	UBYTE alpha;
    BOOL retval = TRUE;
	ULONG RPixel;
	ULONG MyPixel;	
    UBYTE pixel32[4];
	UBYTE rpixel32[4];
    BOOL Is_Pixel = FALSE;
    int width, height, depth;
    struct BitMapHeader *bmhd;
    UBYTE *pixelbuffer;
	LONG pixelateSize = 2;
    
    /* Find Width, Height & Depth of Image */
    bmhd = readbmhd_by_datatype(infilename2);
    width = bmhd->bmh_Width;
    height = bmhd->bmh_Height;
    depth = bmhd->bmh_Depth;
    bpp = (depth/8);
    
    pixelbuffer = (UBYTE *)AllocMem(width * height * bpp, MEMF_ANY);
    
    retval = ReadPixels_by_datatype(pixelbuffer, infilename2, bpp);
    
    /* Increment Band Offset */
    //if(band == 0)
    //No band offset
    if(band == 1)
    {
       //a,c,e,g
       if(dir == 'a') x -= 1;
       if(dir == 'c') y -= 1;
       if(dir == 'e') x += 1;
       if(dir == 'g') y += 1;
       
       //b,d,f,h
       if(dir == 'b') y -= 1;
       if(dir == 'd') y -= 1;
       if(dir == 'f') y += 1;
       if(dir == 'h') y += 1;       
    }
    if(band == 2)
    {
       //a,c,e,g
	   if(dir == 'a') x -= 2;
       if(dir == 'c') y -= 2;
       if(dir == 'e') x += 2;
       if(dir == 'g') y += 2;       
       
	   //b,d,f,h
       if(dir == 'b') y -= 2;
       if(dir == 'd') y -= 2;
       if(dir == 'f') y += 2;
       if(dir == 'h') y += 2;
    } 
    

    /* Coordinates of Current Pixel */
    srce_xy = (y * width + x) * 4;
    Printf("Check Pixel: Color: %s\n", color);
    Printf("Check Pixel: X: %d\n", x);
    Printf("Check Pixel: Y: %d\n", y); 



	//Sample the pixels in the rasterport
	//Compare them to the original pixels	
	//If the pixel is white, gold, or orange
	//& If the pixel has changed use it instead		
	j = (x * pixelateSize - 1) + srce_x;        
    i = (y * pixelateSize - 1) + srce_y; //xx = 0,1 //yy = 0,1
	//WriteRGBPixel(win->RPort, j + xx + 22, i + yy + 12, MyPixel);
	RPixel = ReadRGBPixel(win->RPort, j + 22, i + 12);
    PutUint32(rpixel32, RPixel); //Read RasterPort Value	  	

    /* Get ARGB Color */
	alpha = pixelbuffer[srce_xy];
	pixel32[0] = 0; //For comparison
    //pixel32[0] = pixelbuffer[srce_xy];
    pixel32[1] = pixelbuffer[srce_xy + 1];
    pixel32[2] = pixelbuffer[srce_xy + 2];
    pixel32[3] = pixelbuffer[srce_xy + 3];

    //Compare original pixel & rasterport pixel
	MyPixel = GetUint32(pixel32);
	//if(MyPixel != RPixel)
	if(alpha == 0)
	{
        //Colors to compare: white, gold, orange
		if((RPixel == 0x00FFFFFF) || (RPixel == 0x00EFE714) || (RPixel == 0x00DFBA45))
		{
			//There's already a colored pixel here!
			//Is_Pixel = TRUE; //Don't place a new pixel
			alpha = 255; 
		}
	}
	Printf ("Alpha32: [0]: %d\n", alpha);
    Printf ("Pixel32: [0]: %d\n", pixel32[0]);
    Printf ("Pixel32: [1]: %d\n", pixel32[1]);
    Printf ("Pixel32: [2]: %d\n", pixel32[2]);
    Printf ("Pixel32: [3]: %d\n", pixel32[3]);

	Printf ("RPixel32: [0]: %d\n", rpixel32[0]);
    Printf ("RPixel32: [1]: %d\n", rpixel32[1]);
    Printf ("RPixel32: [2]: %d\n", rpixel32[2]);
    Printf ("RPixel32: [3]: %d\n", rpixel32[3]);

    //colored pixels with alpha >= 200 are considered perimeter pixels.       
    //perimeter pixels are 'pixels' while all others are considered 'non-pixels'. 
    //perimeter pixels will have alpha = 255 but there are some exceptions such as colored pixels.

    if(alpha == 255) Is_Pixel = TRUE;
    else if(alpha < 255)
    {
        //Printf ("Pixel32 Test\n");
        if((alpha > 0) && (alpha < 255)) Is_Pixel = TRUE;
        if(alpha == 0) Is_Pixel = FALSE;               
    }

	/* Write pixel to original then write to large image */

    if(Is_Pixel == FALSE)
    {		
        /* Write the colored mask pixels */
        Write_Mask(color, srce_x, srce_y, x, y, win);
        Printf("Write Mask: Color - %s\n", color);
        Printf("Write Mask: X: %d\n", x);
        Printf("Write Mask: Y: %d\n", y);			
    }
	FreeMem(pixelbuffer, width * height * bpp);

	//return Is_Pixel;
}

/*********************************************************************************************/

static void Write_Mask(char *color, int srce_x, int srce_y, int x, int y, struct Window *win)
{
    int i, j;
    int xx, yy;
    int srce_xy;
    ULONG MyPixel;
    UBYTE pixel32[4];
    LONG pixelateSize = 2;
    
    j = (x * pixelateSize - 1) + srce_x;        
    i = (y * pixelateSize - 1) + srce_y;

	if(stricmp(color, "white")==0)
        {        
            pixel32[0] = 0;
            pixel32[1] = 255;
            pixel32[2] = 255;
            pixel32[3] = 255;        
        }
        else if(stricmp(color, "gold")==0)
        {
            pixel32[0] = 0;
            pixel32[1] = 239;
            pixel32[2] = 231;
            pixel32[3] = 20;        
        }
        else if(stricmp(color, "orange")==0)
        {
            pixel32[0] = 0;
            pixel32[1] = 223;
            pixel32[2] = 186;
            pixel32[3] = 69;        
        }
        else if(stricmp(color, "black")==0)
        {
            pixel32[0] = 0;
            pixel32[1] = 0;
            pixel32[2] = 0;
            pixel32[3] = 0;        
        }
        MyPixel = GetUint32(pixel32);

    /* For each pixel in the pixelateSize set it to the current color */
    for(xx = 0; xx < pixelateSize; xx++)
    {
        for(yy = 0; yy < pixelateSize; yy++)
        {
            /* Use (x+j) & (y+i) to add an artificial grid to the image */
            //WriteRGBPixel(win->Rport, (x+j) + xx + 45, (y+i) + yy + 25, MyPixel);
            WriteRGBPixel(win->RPort, j + xx + 22, i + yy + 12, MyPixel);
        }
    }       
    
}

/*********************************************************************************************/
